#include <avr/io.h>
#include <math.h>
#include <stdint.h>
#include <avr/delay.h>
#include "lcd-routines.h"


double x=0;
int const mux=0;
double R=0;
double T=0;
double const A=-3.9083;
double const B=15.27480889;
double const C=0.00231;
double const D=0.001155;

void ausgeben(void)
{
	lcd_init();
	char Buffer[20];
	dtostrf(T,2,2,Buffer);
	set_cursor(0,0);
	lcd_string(Buffer);
	lcd_string(" 'C");
	lcd_command(0x40);
	lcd_string("HALLO");
}
	
void adw(mux)
{
	int i=0;
	uint16_t result;

	ADCSRA=(1<<ADEN)|(1<<ADPS1)|(1<<ADPS0);
	ADMUX= mux;
	ADMUX|=(1<<REFS1)|(1<<REFS0);
	ADCSRA|=(1<<ADSC);
	while(ADCSRA & (1<<ADSC))
	{}
	result=ADCW;
	
	for(i=0;i<4;i++)
	{
		ADCSRA|=(1<<ADSC);
		while(ADCSRA & (1<<ADSC))
		{}
		x=x+ADCW;
	}
	ADCSRA&=~(1<<ADEN);
    x=x/5;
}
void aktualisieren(void)
{
	adw(0);
	ausgeben();
}
void temperaturberechnen(void)
{
	R=x*4.8828125*5.6/(5-x*0.0048828125);
	T=(A+sqrt(B-C*(1000-R)))/D;
}
void warte(void)
{
	int i=0;
	for (i=0;i<100;i++)
	{
		_delay_ms(10);
	}
}
int main(void)
{	
	while(1)
	{	
		warte();
		adw();
		temperaturberechnen();
		ausgeben();
	}
	return 0;

}
